/**
 * @license
 * Copyright � 2014 Intuilab
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
 *
 * The Software is provided "as is", without warranty of any kind, express or implied, including but not limited to the warranties of merchantability,
 * fitness for a particular purpose and noninfringement. In no event shall the authors or copyright holders be liable for any claim, damages or other liability,
 * whether in an action of contract, tort or otherwise, arising from, out of or in connection with the Software or the use or other dealings in the Software.
 *
 * Except as contained in this notice, the name of Intuilab shall not be used in advertising or otherwise to promote the sale,
 * use or other dealings in this Software without prior written authorization from Intuilab.
 */


 
/**
 * Inheritance on EventEmitter base class
 * @type {EventEmitter}
 */
MemoryCard.prototype = new EventEmitter();        // Here's where the inheritance occurs
MemoryCard.prototype.constructor = MemoryCard;
 
 /**
 * Creates a MemoryCard Object
 * @constructor
 */
function MemoryCard() {
    var mediaURL = "";
    var cardId = 0;
	var cardValue = 0;
	var isEnabled = true;
	var isSelected = false;

	Object.defineProperty(this, 'MediaURL',{
		enumerable: true,
        get: function(){ return mediaURL; },
        set: function(value){
            if(mediaURL != value){
                mediaURL = value;                
                this.emit('MediaURLChanged');
            }
        }
    });
	
	Object.defineProperty(this, 'CardId',{
		enumerable: true,
        get: function(){ return cardId; },
        set: function(value){
            if(cardId != value){
                cardId = value;                
                this.emit('CardIdChanged');
            }
        }
    });
	Object.defineProperty(this, 'CardValue',{
		enumerable: true,
        get: function(){ return cardValue; },
        set: function(value){
            if(cardValue != value){
                cardValue = value;                
                this.emit('CardValueChanged');
            }
        }
    });
	Object.defineProperty(this, 'IsEnabled',{
		enumerable: true,
        get: function(){ return isEnabled; },
        set: function(value){
            if(isEnabled != value){
                isEnabled = value;                
                this.emit('IsEnabledChanged');
            }
        }
    });
	Object.defineProperty(this, 'IsSelected',{
		enumerable: true,
        get: function(){ return isSelected; },
        set: function(value){
            if(isSelected != value){
                isSelected = value;                
                this.emit('IsSelectedChanged');
            }
        }
    });
	
}


